//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    TmaHalfPeriod   = 12;
extern int    TmaPrice        = PRICE_CLOSE;
extern int    MaPeriod        = 26;
extern int    MaMethod        = MODE_EMA;
extern int    MaPrice         = PRICE_CLOSE;
extern bool   AlertsOn        = false;
extern bool   AlertsOnCurrent = true;
extern bool   AlertsMessage   = true;
extern bool   AlertsSound     = false;
extern bool   AlertsEmail     = false;

//
//
//
//
//

double tma[];
double ma[];
double state[];
double hiu[];
double hid[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,hiu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hid); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,tma);
   SetIndexBuffer(3,ma);
   SetIndexBuffer(4,state);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(TmaHalfPeriod,Bars-counted_bars),Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      hiu[i]   = EMPTY_VALUE;
      hid[i]   = EMPTY_VALUE;
      tma[i]   = icTma(TmaHalfPeriod,TmaPrice,i);
      ma[i]    = iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i);
      state[i] = state[i+1]; 
         if (tma[i] > ma[i]) state[i] =  1;
         if (tma[i] < ma[i]) state[i] = -1;
         if (state[i] ==  1) hiu[i] = 1;
         if (state[i] == -1) hid[i] = 1;
   }       
   manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

double icTma(int period, int price, int i)
{
   int j,k;
   double sum  = (period+1)*iMA(NULL,0,1,0,MODE_SMA,price,i);
   double sumw = (period+1);

      //
      //
      //
      //
      //
      
      for(j=1, k=period; j<period; j++,k--)
      {
         sum  += iMA(NULL,0,1,0,MODE_SMA,price,i+j)*k;
         sumw += k;
         if (j<=i)
         {
               sum  += iMA(NULL,0,1,0,MODE_SMA,price,i-j)*k;
               sumw += k;
         }
      }
   return(sum/sumw);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

      //
      //
      //
      //
      //
      
      if (state[whichBar]!= state[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (state[whichBar] ==  1) doAlert(time1,mess1," T3 crossed ma up");
            if (state[whichBar] == -1) doAlert(time1,mess1," T3 crossed ma down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" T3 ma crosses",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}

